/**休眠 */
function sleep(ms) {
  return new Promise((resolve) => setTimeout(resolve, ms));
}

/**字符串拼接引号 */
function jointsQuote(string) {
  return `"${string}"`;
}

/**截取指定文本内容 */
function sliceAssignedText(text, leftText, rightText) {
  let leftIndex = text.indexOf(leftText);
  if (leftIndex === -1) {
    return null;
  }
  leftIndex += leftText.length;
  const rightIndex = text.indexOf(rightText, leftIndex);
  if (rightIndex === -1) {
    return null;
  }
  return text.substring(leftIndex, rightIndex);
}

/**请求器 */
async function fetchText(url, options = {}) {
  try {
      const response = await fetch(url, options);
      if (!response.ok) {
          throw new Error(`HTTP error! status: ${response.status}`);
      }
      const data = await response.text();
      return data;
  } catch (error) {
      console.error('Fetch error:', error);
      throw error;
  }
}

