let db;
const request = indexedDB.open("ArrayDatabase", 1);
request.onsuccess = function (event) {
  db = event.target.result;
};
request.onerror = function (event) {
  console.error("数据库打开/创建失败:", event.target.error);
};
request.onupgradeneeded = function (event) {
  //初始化
  const db = event.target.result;
  const objectStore = db.createObjectStore("ArrayObjectStore", {
    keyPath: "id",
    autoIncrement: true,
  });
  objectStore.createIndex("qx_hook", "qx_hook", { unique: false });
};

/**数据库添加数据 */
function addDBDataList(db, dataArray) {
  const transaction = db.transaction(["ArrayObjectStore"], "readwrite");
  const objectStore = transaction.objectStore("ArrayObjectStore");
  const request = objectStore.add({ qx_hook: dataArray });
  const count = objectStore.count();
  count.onsuccess = function (event) {
    document.getElementById("grabCount").innerText = `${getMessage("bu_huo")}[${event.target.result}]`
  }
  request.onerror = function (event) {
    console.error("添加数据失败:", event.target.error);
  };
}

/**数据库清空数据 */
function removeDBDataList(db) {
  const transaction = db.transaction(["ArrayObjectStore"], "readwrite");
  const objectStore = transaction.objectStore("ArrayObjectStore");
  const request = objectStore.clear();
  request.onerror = function (event) {
    console.error("清空失败时的回调:", event.target.error);
  };
}

/**导出数据到表 */
function ExportForm(db) {
  const transaction = db.transaction(["ArrayObjectStore"], "readonly");
  const objectStore = transaction.objectStore("ArrayObjectStore");
  // 获取对象存储空间的全部数据
  const request = objectStore.getAll();
  request.onsuccess = function (event) {
    let csvContent =
      [
        "Name",
        "Description",
        "Fulladdress",
        "Street",
        "Municipality",
        "Categories",
        "Time Zone",
        "Amenities",
        "Phone",
        "Phones",
        "Claimed",
        "Review Count",
        "Average Rating",
        "Review URL",
        "Google Maps URL",
        "Latitude",
        "Longitude",
        "Website",
        "Domain",
        "Opening Hours",
        "Featured Image",
        "Cid",
        "Fid",
        "Place Id",
      ].join(",") +
      "\r\n"; // 添加CSV标题行
    const dataArray = event.target.result;
    for (let icsv = 0; icsv < dataArray.length; icsv++) {
      // console.log("读取的数据:", dataArray[icsv]["qx_hook"]);
      csvContent += dataArray[icsv]["qx_hook"].join(",") + "\r\n";
    }

    // 触发下载
    const link = document.createElement("a");
    const blob = new Blob(["\uFEFF" + csvContent], { type: 'text/csv;charset=utf-8;' });
    link.setAttribute("href", URL.createObjectURL(blob));
    link.setAttribute("download", "data11.csv");
    document.body.appendChild(link);
    link.click();
  };
  request.onerror = function (event) {
    console.error("读取数据失败：", event.target.error);
  };
}