
/**设置元素样式 */
function setElementStyles(element, styles) {
  Object.assign(element.style, styles);
}

/**消息提示 */
function Message(message, timer = 3000) {
  // 创建消息框元素
  const messageBox = document.createElement('div');
  messageBox.innerText = message;
  setElementStyles(messageBox, {
    position: 'fixed',
    top: '-100px',
    left: '50%',
    transform: 'translateX(-50%)',
    backgroundColor: '#1890ff',
    color: 'white',
    padding: '8px 16px',
    borderRadius: '5px',
    boxShadow: '0 4px 8px rgba(0, 0, 0, 0.1)',
    fontSize: '14px',
    opacity: '0',
    transition: 'top 0.5s ease, opacity 0.5s ease',
  })
  document.body.appendChild(messageBox);

  setTimeout(() => {
    messageBox.style.top = '20px';
    messageBox.style.opacity = '1';
  }, 10);

  // 移除消息框
  setTimeout(() => {
    messageBox.style.top = '-100px';
    messageBox.style.opacity = '0';
    
    setTimeout(() => {
      document.body.removeChild(messageBox);
    }, 500);
  }, timer);
}

/**获取指定层级的祖先元素 */
function getAncestorElement(element, levels) {
  if (element === null) {
    document.querySelector(".searchboxinput")?.focus();
    Message(chrome.i18n.getMessage("ti_shi_no"));
    throw new Error("未找到祖先元素，不在列表中，无法抓取数据，尝试打开搜索框");
  }
  for (let i = 0; i < levels; i++) {
    element = element.parentElement;
    if (!element) {
      return null;
    }
  }
  return element;
}

/**检测列表最后一个元素 */
function LoopWaitingToGetTheElement(parent, callback) {
  const parentList = parent.children;
  return new Promise((resolve) => {
    const checkLastElement = () => {
      // 获取最后一个元素
      const lastElement = parentList[parentList.length - 1];

      if (callback(lastElement)) {
        resolve(true);
      } else {
        // 不符合条件, 500毫秒后重新检查
        setTimeout(checkLastElement, 500); 
      }
    };

    checkLastElement();
  });
}

/**添加日志 */
function addLog(message) {
  const logTextarea = document.getElementById("logTextarea");
  logTextarea.value += " · " + message + "\n";
  logTextarea.scrollTop = logTextarea.scrollHeight;
}

/**获取列表容器 */
function getParentElement() {
  const targetElement = document.querySelector(`.${enums.aLinkElementClass}`);
  const parentBox = getAncestorElement(targetElement, 3);
  return parentBox;
}