function sdk_appid() {return chrome.runtime.getManifest().author;}// 返回应用程序ID。读取配置文件里面的author为APPID
function sdk_api() {return 'https://pay.extensiondata.com';}// 返回API的URL
function sdk_i18n(key) {return chrome.i18n.getMessage(key);}
function sdk_translatePage() {document.querySelectorAll('[data-i18n]').forEach(element => {element.innerHTML = chrome.i18n.getMessage(element.dataset.i18n);});}
function sdk_oauth2() {// 返回OAuth2配置
    return {
        client_id: '302141211753-1ktvertkqcsnu87qel2r3li76mg1llth.apps.googleusercontent.com',
        redirect_uri: 'https%3A//rapid-waterfall-273a.chromeextensions.workers.dev/oauth2callback'
    };
}
function sdk_isWorkerEnv() {
    if (typeof self !== 'undefined' && typeof WorkerGlobalScope !== 'undefined' && self instanceof WorkerGlobalScope) {return true;}// 检查 1: 检查是否存在 self 对象和 WorkerGlobalScope
    if (typeof window === 'undefined') {return true;}// 检查 2: 检查是否不存在 window 对象
    if (typeof document === 'undefined') {return true;}// 检查 3: 检查是否不存在 document 对象
    if (typeof importScripts === 'function') {return true;}// 检查 4: 检查是否存在 importScripts 函数（Web Worker 特有）
    if (typeof navigator === 'undefined') {return true;}// 检查 5: 检查是否不存在 navigator 对象
    if (typeof WorkerNavigator !== 'undefined' && navigator instanceof WorkerNavigator) {return true;}// 检查 6: 检查是否存在 WorkerNavigator
    try {
        window.tempProperty = 'test';//当插件处于后台，没有window属性，前台才有【处于前台返回False】【处于后台返回True】
        delete window.tempProperty;
        return false;// 如果能成功修改 window 对象，很可能不是 Worker 环境
    } catch (e) {return true;}// 如果无法修改 window 对象，可能是 Worker 环境或者严格的安全环境
    if (self !== window) {return true;}// 检查 8: 检查 self 和 window 是否相同（在 Worker 中通常不同）
    return false;// 如果所有检查都未返回 true，则假定不是 Worker 环境
}
function sdk_extractURLParameter(url, paramName) {
    // 先尝试直接从URL参数中获取
    const paramRegex = new RegExp(`[?&]${paramName}=([^&]*)`);
    const match = url.match(paramRegex);
    if (match) {
        return decodeURIComponent(match[1]);
    }
    
    // 如果直接获取为空,则尝试从data参数中获取
    const dataParam = new URLSearchParams(url.split('?')[1]).get('data');
    if (dataParam) {
        try {
            const dataObj = JSON.parse(decodeURIComponent(dataParam));
            return dataObj[paramName] || null;
        } catch (e) {
            console.error('Error parsing data parameter:', e);
            return null;
        }
    }
    return null;
}




function up_end_at() {
	chrome.storage.local.get('userInfo', e => {
		const now = Date.now();// 首先,获取上次执行的时间戳
		const lastExecutionTime = chrome.storage.local.get('userInfo') || 0;
		const timeSinceLastExecution = now - lastExecutionTime;
		
		if (timeSinceLastExecution >= 1 * 60 * 60 * 1000) {// 检查是否已经过了1小时
			if (e.userInfo) {
				chrome.storage.local.set({lastExecutionTime: now});// 更新最后执行时间
				chrome.windows.create({
					url: sdk_api() + "/NbSdk/GetUserVip?appid="+ e.userInfo.appid +"&mail="+ encodeURIComponent(e.userInfo.mail)+"&ver="+ encodeURIComponent(chrome.runtime.getManifest().version),
					type: "popup",
					width: 2,
					height: 2
				}, popupWin => {
					let listener_lq = function (changes, namespace) {
						if (namespace === 'local' && changes.userInfo) {
							chrome.storage.onChanged.removeListener(listener_lq);
							chrome.windows.remove(popupWin.id);
						}
					};
					chrome.storage.onChanged.addListener(listener_lq);
				});
			}
		}
	});
}
function addContactBar() {
	chrome.storage.local.get('userInfo', e => {
		const contactButton = `<a id="nb-contact-info" href="https://lxkff.pages.dev?appid=`+ encodeURIComponent(e.userInfo.appid) +`&mail=`+ encodeURIComponent(e.userInfo.mail) +`&end_at=`+ encodeURIComponent(e.userInfo.end_at) +`&t=`+ encodeURIComponent(e.userInfo.t) +`&end_b=`+ encodeURIComponent(Math.floor(Date.now() / 1000)) +`" target="_blank"><svg viewBox="0 0 24 24" width="30" height="30"><path fill="#fff" d="M17.472 14.382c-.297-.149-1.758-.867-2.03-.967-.273-.099-.471-.148-.67.15-.197.297-.767.966-.94 1.164-.173.199-.347.223-.644.075-.297-.15-1.255-.463-2.39-1.475-.883-.788-1.48-1.761-1.653-2.059-.173-.297-.018-.458.13-.606.134-.133.298-.347.446-.52.149-.174.198-.298.298-.497.099-.198.05-.371-.025-.52-.075-.149-.669-1.612-.916-2.207-.242-.579-.487-.5-.669-.51-.173-.008-.371-.01-.57-.01-.198 0-.52.074-.792.372-.272.297-1.04 1.016-1.04 2.479 0 1.462 1.065 2.875 1.213 3.074.149.198 2.096 3.2 5.077 4.487.709.306 1.262.489 1.694.625.712.227 1.36.195 1.871.118.571-.085 1.758-.719 2.006-1.413.248-.694.248-1.289.173-1.413-.074-.124-.272-.198-.57-.347m-5.421 7.403h-.004a9.87 9.87 0 01-5.031-1.378l-.361-.214-3.741.982.998-3.648-.235-.374a9.86 9.86 0 01-1.51-5.26c.001-5.45 4.436-9.884 9.888-9.884 2.64 0 5.122 1.03 6.988 2.898a9.825 9.825 0 012.893 6.994c-.003 5.45-4.437 9.884-9.885 9.884m8.413-18.297A11.815 11.815 0 0012.05 0C5.495 0 .16 5.335.157 11.892c0 2.096.547 4.142 1.588 5.945L.057 24l6.305-1.654a11.882 11.882 0 005.683 1.448h.005c6.554 0 11.89-5.335 11.893-11.893a11.821 11.821 0 00-3.48-8.413z"/></svg></a>`;
		document.body.insertAdjacentHTML('beforeend', contactButton);
		const style = document.createElement('style');
		style.textContent = `#nb-contact-info {position: fixed;right: 0;top: 50%;transform: translateY(-50%);width: 5px;height: 100px;background: #25D366;transition: 0.3s;cursor: pointer;z-index: 99999;display: block;}
		  #nb-contact-info:hover {width: 50px;}
		  #nb-contact-info svg {display: none;position: absolute;top: 50%;left: 50%;transform: translate(-50%, -50%);}
		  #nb-contact-info:hover svg {display: block;}`;
		document.head.appendChild(style);
	});
}

(() => {
    if (chrome.i18n.getUILanguage() === 'zh' || chrome.i18n.getUILanguage() === 'zh-CN' || chrome.i18n.getUILanguage() === 'zh_CN'){return;}//判断如果是，中国人就免费使用
    if (sdk_isWorkerEnv()) {
        chrome.tabs.onUpdated.addListener(function (tabId, changeInfo, tab) {//oauthSuccess是登录成功 subscriberPaySuccess是支付成功
			if (tab.url.includes(sdk_appid())) {//url里面必须有，本插件的Appid，避免冲突
			
			
				if (tab.url.includes('mail') && (tab.url.includes('/NbSdk/oauthSuccess') || tab.url.includes('/NbSdk/subscriberPaySuccess?code=200'))){
					chrome.storage.local.set({
						userInfo: {
							appid: sdk_extractURLParameter(tab.url, 'appid'),
							mail: sdk_extractURLParameter(tab.url, 'mail'),
							end_at: sdk_extractURLParameter(tab.url, 'end_at'),
							r: Math.random().toString(16)
						}
					});
				}
				if (tab.url.includes('code') && tab.url.includes('end_at') && tab.url.includes('/NbSdk/GetUserVip')) {
					if(sdk_extractURLParameter(tab.url, "code") == '200'){
						chrome.storage.local.get('userInfo', e => {
							if (e.userInfo) {
								e.userInfo.end_at = sdk_extractURLParameter(tab.url, "end_at");
								chrome.storage.local.set({userInfo: e.userInfo}); 
							}
						});
					}
				}
			}
        });
    }else{
		up_end_at();//更新到期时间
        if (!window.location.href.includes('nbsdk'))
            chrome.storage.local.get('userInfo', e => {
                if (e.userInfo) {
                    if (e.userInfo.end_at <= 0 || e.userInfo.end_at <= Math.floor(Date.now() / 1000)){// 检查用户订阅是否已过期
						chrome.runtime.sendMessage({action: "NbSdk_expired"});
						const urlParams = new URLSearchParams(window.location.search);
						const paramValue = urlParams.get('web'); // 替换 为您实际的参数名
						const mask = document.createElement('div');// 如果订阅已过期，创建一个遮罩层
						mask.id = 'blur-overlay';
						Object.assign(mask.style,{position:'fixed',top:'0',left:'0',width:'100%',height:'100%',backgroundColor:'rgba(255, 255, 255, 0.1)',display:'flex',justifyContent:'center',alignItems:'center',zIndex:'9999'});

						// 为遮罩层添加点击事件，点击时打开支付页面
                        mask.addEventListener('click', () => {
                            chrome.windows.create({
                                url: chrome.runtime.getURL("/nbsdk/payment/payment.html"),
								type: "normal",
								focused: true,
								state: "normal"
                            }, popupWin => {
								// 添加一个监听器，等待支付成功
                                let listener = function (changes, namespace) {
                                    if (namespace === 'local' && changes.userInfo) {
                                        chrome.storage.onChanged.removeListener(listener);// 支付成功后，移除监听器，关闭支付窗口，并刷新页面
                                        chrome.windows.create({
                                            url: chrome.runtime.getURL("/nbsdk/payment/success.html"),
											type: "popup",
											width: Math.round(window.screen.width / 2),
											height: Math.round(window.screen.height / 2),
											left: Math.round(window.screen.width / 4),
											top: Math.round(window.screen.height / 4)
                                        });
                                        chrome.windows.remove(popupWin.id);
										chrome.runtime.sendMessage({action: "NbSdk_paySuccess"});//支付成功
                                        window.location.reload();
                                    }
                                };
                                chrome.storage.onChanged.addListener(listener);
                            });
                        });
                        document.body.appendChild(mask);// 将遮罩层添加到页面
						if(paramValue == '1'){
							mask.click();//如果是外部拉起popu页面，直接拉起支付
						}
                    }else{
						chrome.runtime.sendMessage({action: "NbSdk_vipSuccess"});// 如果还处于订阅期
					}
					addContactBar();
                } else {// 如果没有用户信息，重定向到登录页面
                    window.location.replace(chrome.runtime.getURL("/nbsdk/login/login.html?ori=" + window.location.pathname));
                }
				
            });
    }
})();