sdk_translatePage();

function addPlanElement(plan) {
    const planElement = document.createElement('div');
    planElement.innerHTML = `
                    <div class="plan" data-plan="${plan.price_id}" data-type="${plan.months}" data-pay="${plan.pay}">
                        <div class="plan-left">
                            <div class="duration">
                                 <span data-i18n="nbsdk_month${plan.months}"></span>
${plan.months === 1 ? '<span class="tag new-user" data-i18n="nbsdk_a10"></span>' : ''}
${plan.months === 3 ? '<span class="tag discount" data-i18n="nbsdk_a11"></span>' : ''}
${plan.months === 12 ? '<span class="tag popular" data-i18n="nbsdk_a12"></span>' : ''}
                            </div>
                            <div class="price">
                                <span class="current">$ ${plan.dis_price}</span>
                            <span class="original">$ ${plan.ori_price}</span>
                            </div>
                        </div>
                        <div class="select-indicator">
                            <svg class="checkmark" viewBox="0 0 24 24">
                                <path d="M9 16.17L4.83 12l-1.42 1.41L9 19 21 7l-1.41-1.41z"/>
                            </svg>
                        </div>
                    </div>`;
    return planElement;
}

const plansContainer = document.querySelector('.plans');
chrome.storage.local.get('userInfo', Mail => {
fetch(sdk_api() + `/NbSdk/Get_Price?appid=${sdk_appid()}&mail=`+ Mail.userInfo.mail)
    .then(response => response.json())
    .then(data => data.data)
    .then(items => {
        items.forEach(item => plansContainer.appendChild(addPlanElement(item)));
        let selectedPlan;
		let type;
		let pay;
        const plans = document.querySelectorAll('.plan');
        plans.forEach(plan => {
            plan.addEventListener('click', function () {
                plans.forEach(p => p.classList.remove('selected'));
                this.classList.add('selected');
                selectedPlan = this.dataset.plan;
				type = this.dataset.type;
				pay = this.dataset.pay;
            });
        });
        selectedPlan = plans[0].dataset.plan;
		type = plans[0].dataset.type;
		pay = plans[0].dataset.pay;
		//console.log('选择计划是:', plans[0]);
		
		var langt = chrome.i18n.getUILanguage();
        plans[0].classList.add('selected');
        document.getElementById('payButton').addEventListener('click', function () {
            chrome.storage.local.get('userInfo', e => {
				window.location.href = sdk_api() + `/NbSdk/Cliak_Pay?appid=${e.userInfo.appid}&mail=${e.userInfo.mail}&price_id=${selectedPlan}&lang=${langt}&type=${type}&pay=${pay}`;
            });//支付成功之后会被重定向到：https://pay.extensiondata.com/NbSdk/subscriberPaySuccess?mail=&sid=
        });
        sdk_translatePage();
    }).catch(error => console.error('Error adding plans:', error));
});
alert(sdk_i18n('nbsdk_a15'));